#!/usr/bin/perl -w    

$sort_by_gammacat = 1;
$ncat = 100; #number of gamma rate categories - only for sorting purposes
$step = 30;  
$nr_of_replicates = 100;
#$outfile = "sort";
#$outformat = "nexus";

my $mtest_block = "#NEXUS 

[! ***** MODELFIT BLOCK -- MODELTEST 3.4 *****]

[The following command will calculate a NJ tree using the JC69 model of evolution]

BEGIN PAUP;
DSet distance=JC objective=ME base=equal rates=equal pinv=0 subst=all negbrlen=setzero;
NJ showtree=no breakties=random;
End;

[!
***** BEGIN TESTING 56 MODELS OF EVOLUTION ***** ]

BEGIN PAUP;


Default lscores longfmt=yes;
Set criterion=like;

[!
** Model 1 of 56 * Calculating JC **]
lscores  1/ nst=1  base=equal  rates=equal  pinv=0
scorefile=model.scores replace; 
[!
** Model 2 of 56 * Calculating JC+I **]
lscores  1/ nst=1  base=equal  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 3 of 56 * Calculating JC+G**]
lscores  1/ nst=1  base=equal  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 4 of 56 * Calculating JC+I+G **]
lscores  1/ nst=1  base=equal  rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 

[!
** Model 5 of 56 * Calculating F81 **]
lscores  1/ nst=1  base=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 6 of 56 * Calculating F81+I **]
lscores  1/ nst=1  base=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 7 of 56 * Calculating F81+G **]
lscores  1/ nst=1  base=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 8 of 56 * Calculating F81+I+G **]
lscores  1/ nst=1  base=est  rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 

[!
** Model 9 of 56 * Calculating K80 **]
lscores  1/ nst=2  base=equal  tratio=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 10 of 56 * Calculating K80+I **]
lscores  1/ nst=2  base=equal  tratio=est  rates=equal  pin=est
scorefile=model.scores  append; 
[!
** Model 11 of 56 * Calculating K80+G **]
lscores  1/ nst=2  base=equal  tratio=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 12 of 56 * Calculating K80+I+G **]
lscores  1/ nst=2  base=equal  tratio=est  rates=gamma  shape=est pinv=est
scorefile=model.scores  append; 
 
[!
** Model 13 of 56 * Calculating HKY **]                
lscores  1/ nst=2  base=est  tratio=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 14 of 56 * Calculating HKY+I **] 
lscores  1/ nst=2  base=est  tratio=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 15 of 56 * Calculating HKY+G **] 
lscores  1/ nst=2  base=est  tratio=est  rates=gamma  shape=est  pinv=0  
scorefile=model.scores  append; 
[!
** Model 16 of 56 * Calculating HKY+I+G **] 
lscores  1/ nst=2  base=est  tratio=est  rates=gamma  shape=est  pinv=est  
scorefile=model.scores  append; 

[!
** Model 17 of 56 * Calculating TrNef **]                            [a b c d e f]
lscores  1/ nst=6  base=equal  rmat=est  rclass=(a b a a e a)  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 18 of 56 * Calculating TrNef+I **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 19 of 56 * Calculating TrNef+G **] 
lscores  1/ nst=6  base=equal rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 20 of 56 * Calculating TrNef+I+G **] 
lscores  1/ nst=6  base=equal  rmat=est rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 

[!
** Model 21 of 56 * Calculating TrN **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 22 of 56 * Calculating TrN+I **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 23 of 56 * Calculating TrN+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 24 of 56 * Calculating TrN+I+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 25 of 56 * Calculating K3P **]                              [a b c d e f]
lscores  1/ nst=6  base=equal  rmat=est  rclass=(a b c c b a)  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 26 of 56 * Calculating K3P+I **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 27 of 56 * Calculating K3P+G **] 
lscores  1/ nst=6  base=equal rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 28 of 56 * Calculating K3P+I+G **] 
lscores  1/ nst=6  base=equal  rmat=est rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 29 of 56 * Calculating K3Puf **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 30 of 56 * Calculating K3Puf+I **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 31 of 56 * Calculating K3Puf+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 32 of 56 * Calculating K3Puf+I+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 33 of 56 * Calculating TIMef **]                            [a b c d e f]
lscores  1/ nst=6  base=equal  rmat=est  rclass=(a b c c e a)  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 34 of 56 * Calculating TIMef+I **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 35 of 56 * Calculating TIMef+G **] 
lscores  1/ nst=6  base=equal rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 36 of 56 * Calculating TIMef+I+G **] 
lscores  1/ nst=6  base=equal  rmat=est rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 37 of 56 * Calculating TIM **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 38 of 56 * Calculating TIM+I **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 39 of 56 * Calculating TIM+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 40 of 56 * Calculating TIM+I+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 41 of 56 * Calculating TVMef **]                            [a b c d e f]
lscores  1/ nst=6  base=equal  rmat=est  rclass=(a b c d b e)  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 42 of 56 * Calculating TVMef+I **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 43 of 56 * Calculating TVMef+G **] 
lscores  1/ nst=6  base=equal rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 44 of 56 * Calculating TVMef+I+G **] 
lscores  1/ nst=6  base=equal  rmat=est rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 45 of 56 * Calculating TVM **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 46 of 56 * Calculating TVM+I **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 47 of 56 * Calculating TVM+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 48 of 56 * Calculating TVM+I+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 49 of 56 * Calculating SYM **]                               [a b c d e f]
lscores  1/ nst=6  base=equal  rmat=est  rclass= (a b c d e f)  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 50 of 56 * Calculating SYM+I **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 51 of 56 * Calculating SYM+G **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=gamma  shape=est pinv=0  
scorefile=model.scores  append; 
[!
** Model 52 of 56 * Calculating SYM+I+G **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=gamma  shape=est pinv=est  
scorefile=model.scores  append; 

[!
** Model 53 of 56 * Calculating GTR **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 54 of 56 * Calculating GTR+I**] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 55 of 56 * Calculating GTR+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est pinv=0  
scorefile=model.scores  append; 
[!
** Model 56 of 56 * Calculating GTR+I+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est pinv=est  
scorefile=model.scores  append; 


LOG STOP;

END;

[
lscores: tree/s
nst: number of substitution types
rmat: rate matrix
base= nucleotide frequencies
rates= rate of evolution for variable sites (same 
shape= alpha parameter of the gamma distribution
pinv= proportion of invariable sites
]

[The likelihood ratio test statistic is calculated as twice the difference between 
the log likelihood scores of the two models constrasted. When the model representing
the null hypothesis is a special case of the alternate model, this statistic 
fits a chi-square distribution with a number of degrees of freedom equal to the 
number of parameters that freely vary between the two models. A detailed explanation 
of the test of the model of DNA substitution can be found in Huelsenbeck and Crandall
Annu. Rev. Ecol. Syst. 1997. 28: 437-466]

[!***  END OF MODELTEST BLOCK  ***]";


my $part1 = "SET
INCREASE = AUTO
AUTOCLOSE = yes;
Begin PAUP;
SET CRITERION = LIKELIHOOD;
DEFAULT LSCORES LONGFMT = yes;
[!
** Calculating best model (AIC) "; 



$part2 = " **]
";


$part3_1 = "HSEARCH START=NJ SWAP=TBR";
$part3_2 = "; DESCRIBETREES / PLOT=PHYLOGRAM; SAVETREES FILE= ";


$part31 = "BOOTSTRAP nreps=1 treefile= ";

$part4 = " FORMAT=NEXUS BRLENS=yes;";

$part5 = "\nLOG STOP;

END;
";

$part41 = " replace=yes brlens=yes search=heuristic/ multrees=no SWAP=TBR;
DESCRIBETREES / PLOT=PHYLOGRAM; 

LOG STOP;

END;
";




my $MAN = <<DESCRIPTION;
This script performs gamma rate based character sorting as described in: 
Goremykin VV, Nikiforova SV, Bininda-Emonds ORP, Automated removal of noisy
data in phylogenomic analyses. JME 2010.71:319-331.
In addition, it can be used to facilitate ML tree building with PAUP*. 

Following programs should be in the path:
paup - named - "paup"
modeltest - named - "mtest"
consense from PHYLIP package - named - "consense"
trepaup2phy script  - named - "trepaup2phy"

synopsis: gamma_sorter.pl arg1 arg2 arg3 arg4 arg5 arg6 arg7
arg1:	name of input alignment in nexus format (produced by SEAVIEW)
arg2:	"boot"/"noboot" - sets bootstrap on/off
arg3:	"1"/"2"/"3" - sets mode of model-fitting, 1 - using NJ tree as a base tree,
	2 - using ML tree built with a fitted model as a base tree, and
	3 - using custom tree as a base tree. 
arg4:   "nexus"/"phylip" - format of the A,B and C partitions to be created. 
arg5:	base file name of the A,B and C partitions to be created.
arg6:	integer - size [pos.] of each shortening step. 
arg7:   [optional:input_treefile_name] If arg3 is set to 3, one can specify the
	name of the file in PHYLIP format, containing the tree, which should be used
	as a base tree for model fitting. If arg7 is not set, the script will
	look for the tree "arg1.usertree" in the current directory.

instead of setting arg3 to "3", and providing a custom tree for assigning rates
to characters, one can use a data-based tree built with topological constraints.
If a tree file named "constraints" (in PHYLIP format) is found in the current directory,
the script will do all the model-fitting and tree-building using the constraints specified 
in this file. This will influence the outcome of the character-sorting.

Note1:

If option is set to "boot" then script starts a certain number of paup runs
simultaneously, each one computing tree for a single bootstrap replica, and
then summarises the resutls in the file *.RESULTS in the current directory.
(On a server with x cpus, that will make bootstrap run x times faster compared
to the standard paup command.) The number of bootstrap replicates is controlled
by the varible \$nr_of_replicates, which must be set within the script.

Note2:

"phylip" format of the partitions is suitable for phyml program. 
This format might not be suitable for other programs.

DESCRIPTION

$#ARGV>=1 || die ($MAN);
$infile = $ARGV[0];
$boot = $ARGV[1];
$mode = $ARGV[2];
$outformat = $ARGV[3];
$outfile = $ARGV[4];
$step = $ARGV[5];



########################################
#reading optional tree for fitting model parameters
#(as an alternative to data-based NJ and ML trees.)
########################################

if ($mode == 3)
{
   if ($#ARGV == 6)
   {
      open VVOD_TREE, "<$ARGV[6]" or die (sprintf ("cannot find user-specified tree file \"$ARGV[6]\""));
      $usertree = <VVOD_TREE>;
      close  VVOD_TREE;
   }
   elsif ((-s "$infile.usertree") && (-T "$infile.usertree"))
   { 
      open VVOD_TREE, "<$infile.usertree" or die (sprintf ("cannot open $2 file for reading"));	    
      $usertree = <VVOD_TREE>;
      close  VVOD_TREE;
   }
   else
   {
      die (sprintf ("cannot find the input tree file \"$infile*usertree\""));
   }
}   

########################################
#reading optional tree providing constraints for ML search
########################################

if ((-s "constraints") && (-T "constraints"))
{ 
   open (VVOD_CONSTRAINTS, "<constraints");
   $tree_constraints = <VVOD_CONSTRAINTS>;
   close VVOD_CONSTRAINTS;
   $constraints1 = "constraints myconstraints = $tree_constraints\n";
   
   open (VIVOD_CONSTRAINTS, ">constraints1");
   print VIVOD_CONSTRAINTS $constraints1;
   close VIVOD_CONSTRAINTS;
   $constraints = 1;
}
else
{
   $constraints = 0;   
}


########################################
#reading sequences from nexus file for sorting
#nexus file should be produced with Seaview or be in sequential format
########################################

$stroki = 0;
if ($sort_by_gammacat == 1)
{
   open (VVOD, "<$infile") or die (sprintf ("cannot open $infile for reading"));
   $count = -1;
   while (defined($stroka = <VVOD>))
   {

      $stroki++;
      if ($stroki == 2)
      { 
	 if ($stroka =~ /saved by seaview/)
         {
            print "NEXUS seaview format";
	    while (defined($stroka = <VVOD>))
            {
	    mark1: if ($stroka =~ /^\[\d+\] \'(.+)\'/ or $stroka =~ /^\[\d+\] (.+)/)
            {
	       $fastacomment = $1;
               $fastacomment =~ s/\r//g;
	       $fastacomment =~ s/\n//g;
	       $count++;
	       $xashnames{$count} = $fastacomment;
	       $seq = "";
	       while (defined($stroka = <VVOD>) and $stroka !~ /^\[|^\;/)
	       {
                 $stroka =~ s/\r//g;
                 $stroka =~ s/\n//g;
	         $stroka =~ s/ +//g;
	         $seq = $seq.$stroka;
	       }
	       $alnlength = length $seq;
	       @stroka = split (//, $seq);
	       $xash{$count} = [ @stroka ];
	       if (defined $stroka){$stroka =~ /^\[/ and goto mark1;}
            }
	    }
	 }   
         else #file is in the sequential format then
         {
            print "NEXUS sequential format";
	    $allowed = 0;
	    while (defined($stroka = <VVOD>))
            {
	       $stroka =~ /matrix/ and $allowed = 1;
               if ($allowed == 1 and $stroka =~ /^([^ ]+)\s+([^ ]+)/)
	       {
	           $count++;
		   $xashnames{$count} = $1;
		   $seq = $2;
        	   $seq =~ s/\r//g;
		   $seq =~ s/\n//g;
		   $alnlength = length $seq;
		   @stroka = split (//, $seq);
		   $xash{$count} = [ @stroka ];
	       }
            }
         }
      }
      	 
   }
   $ntax = $count + 1;
}
open (VIVOD_P, ">mtest_block");
print VIVOD_P $mtest_block;
close VIVOD_P;


########################################
#first mode of model-fitting
########################################

if ($constraints == 1)
{
   system "cat $infile constraints1 mtest_block >  $infile.mtestraw";	  
}
else
{
   system "cat $infile mtest_block >  $infile.mtestraw";     
}

if ($mode == 1 or $mode == 2)
{
   open (VVOD_MT, "<$infile.mtestraw");
   open (VIVOD_MT, ">$infile.mode1.mtest");
   while (defined($linia = <VVOD_MT>))
   {   
      if (($linia =~ /(^NJ showtree=no breakties=random)/) && ($constraints != 0))
      {
        $linia = "$1 enforce=yes;\n";
        print VIVOD_MT $linia;	   
      }      
      elsif ($linia =~ /^(scorefile\=)model\.scores( +[^ ]+)/)
      {
        $linia = "$1$infile.mode1.models$2\n";
        print VIVOD_MT $linia;	   
      }
      else
      {
        print VIVOD_MT $linia;	   
      }
   }
   close VVOD_MT;
   close VIVOD_MT;

   system " paup -n $infile.mode1.mtest";
   system "mtest < $infile.mode1.models > $infile.mode1.bestmodel";


   open (VVODA, "<$infile.mode1.bestmodel");
   $click = 0;
   while (defined($stroka = <VVODA>))
   {
      if ($stroka =~ /Akaike/)
      {
	$click = 1;
      }  
      if ($click == 1)
      {
	if ($stroka =~ /^Likelihood settings from best-fit model \((.+)\)/)
	{
	  $modelname = $1;     
	}
	if ($stroka =~ /^BEGIN PAUP/)
	{
	  $stroka = <VVODA>;
	  $model = $stroka;
	  print "mode1 optimal model found:\n$model\n";
	  last;
	}
      }
   }
}


########################################
#second and third modes of model-fitting
########################################


if ($mode == 2 or $mode == 3)
{
   open (VVOD_MT, "<$infile.mtestraw");
   open (VIVOD_MT, ">$infile.mode$mode.mtest");
   while (defined($linia = <VVOD_MT>))
   {
      if ($linia =~ /(\[)The following command will calculate a NJ tree using the JC69 model of evolution(\]\n)/)
      {
	if ($mode == 2)
	{
	   $linia = "$1The following command will calculate a ML tree using $modelname model fitted using NJ tree$2";
	   print VIVOD_MT $linia;
	   while (defined($linia = <VVOD_MT>) and $linia !~ "End\;\n")
	   {
	   }   
	   if ($constraints == 0)
	   {
	      print VIVOD_MT "SET INCREASE = AUTO AUTOCLOSE = yes;\nBEGIN PAUP;\nDEFAULT LSCORES LONGFMT = yes;\nSET CRITERION = LIKELIHOOD;\n$model$part3_1$part3_2$infile"."_"."$modelname.mode1.nexustree $part4\n";
	   }
	   else
	   {
	      print VIVOD_MT "SET INCREASE = AUTO AUTOCLOSE = yes;\nBEGIN PAUP;\nDEFAULT LSCORES LONGFMT = yes;\nSET CRITERION = LIKELIHOOD;\n$model$part3_1 enforce=yes$part3_2$infile"."_"."$modelname.mode1.nexustree $part4\n";
	   }
	}
	elsif ($mode == 3)
	{
	   $linia = "$1The following command will export a user-defined ML tree$2";
	   print VIVOD_MT $linia;
	   while (defined($linia = <VVOD_MT>) and $linia !~ "End\;\n")
	   {
	   }
	   print VIVOD_MT "BEGIN TREES;\ntree usertree = [&U] $usertree";
	   print VIVOD_MT "End\;\n";
	}
      }
      elsif ($linia =~ /^(scorefile\=)model\.scores( +[^ ]+)/)
      {
	$linia = "$1$infile.mode$mode.models$2\n";
	print VIVOD_MT $linia;         
      }
      else
      {  
       print VIVOD_MT $linia;
      }
   }
   close VVOD_MT;
   close VIVOD_MT;

   system "nohup paup -n $infile.mode$mode.mtest";
   system "mtest < $infile.mode$mode.models > $infile.mode$mode.bestmodel";

   open (VVODA, "<$infile.mode$mode.bestmodel");
   $click = 0;
   while (defined($stroka = <VVODA>))
   {
      if ($stroka =~ /Akaike/)
      {
	 $click = 1;
      }  
      if ($click == 1)
      {
	 if ($stroka =~ /^Likelihood settings from best-fit model \((.+)\)/)
	 {
	   $modelname = $1;	
	 }
	 if ($stroka =~ /^BEGIN PAUP/)
	 {
	    $stroka = <VVODA>;
	    $model = $stroka;
	    print "mode 2/3 optimal model found:\n$model\n";
	    last;
	 }
      }
   }
}

########################################
#building ML tree with PAUP
########################################

$model =~ m/Lset(.+);\n/;
$modelset = $1;
open (VVODC, "<$infile");
$alignment = "";

while (defined($stroka = <VVODC>) and ($stroka !~ "^end;" or $stroka !~ "^END;"))
{
   $alignment = $alignment.$stroka;
}
close VVODC;

open (VIVODA, ">$infile.mode$mode.fixed") or die (sprintf ("cannot open $infile.mode$mode.fixed file for writing"));
if ($constraints == 0)
{
   print VIVODA "$alignment$part1$modelname$part2$model$part3_1$part3_2$infile"."_"."$modelname.mode$mode.nexustree $part4$part5"; 
}
else
{
   print VIVODA "$alignment$constraints1$part1$modelname$part2$model$part3_1 enforce=yes$part3_2$infile"."_"."$modelname.mode$mode.nexustree $part4$part5"; 
}
close VIVODA;
system "nohup paup -n $infile.mode$mode.fixed";


########################################
#reformatting ML tree to phylip format
########################################

system "trepaup2phy nexustree";
$treename = "$infile"."_"."$modelname.mode$mode.nexustree#";
open (VVODTREE, "<$treename") or die (sprintf ("cannot open $modelname.mode$mode.nexustree# file for reading"));
$tree_tosort = <VVODTREE>;
close VVODTREE;

########################################
#sorting by gamma cathegories
#if setting number of gamma cathegories to 100 will cause "out of memory" error, then	 
#the number of gamma cathegories will be decreased by 1 till paup produces output file  
########################################

if ($sort_by_gammacat == 1)
{

   $output = 0;$size = 0;
   while ($output == 0)
   { 
   
      open (VIVODA, ">$infile.mode$mode.fixedforsorting") or die (sprintf ("cannot open $infile.mode$mode.fixedforsorting file for writing"));
      print VIVODA "$alignment$part1$modelname$part2\nBEGIN TREES;\ntree usertree = [&U] $tree_tosort\nEnd\;
lscore 1\/ $modelset ncat=$ncat sitelikes=yes categlikes=yes scorefile=$infile"."_"."$modelname.mode$mode.lscores replace=yes;$part5"; 
      close VIVODA;
      system "nohup paup -n $infile.mode$mode.fixedforsorting";
   
      $file_to_check = "$infile"."_"."$modelname.mode$mode.lscores";
      if (-e $file_to_check)
      {
         $size = (-s $file_to_check);
      }
      if ($size > 0)
      {   
          $output = 1;
      }
      else
      {
         $ncat--;
      }      
   }     
   open (VVOD_GAMMACAT, "<$infile"."_"."$modelname.mode$mode.lscores");
   {
      $stroka = <VVOD_GAMMACAT>;$stroka = <VVOD_GAMMACAT>;
      $sites = -1;
      while (defined($stroka = <VVOD_GAMMACAT>) and $stroka =~ /(\d+)\n/)
      {
	 $sites++;
	 for $species (sort {$a <=> $b} keys %xash)
	 {	  
	    push @{$xash_out{$species}{$1}}, $xash{$species}[$sites];
	 }
      }
   }
   close VVOD_GAMMACAT;



   for $species (sort {$a <=> $b} keys %xash_out)
   { 
      for $gamma_categoria (sort {$a <=> $b} keys %{$xash_out{$species}})
      {
	 for $l (0.. $#{$xash_out{$species}{$gamma_categoria}})
	 {
	    push @{$xash_out1{$species}}, $xash_out{$species}{$gamma_categoria}[$l];
	    push @{$xash_dist{$species}}, $gamma_categoria;
	 }
      }
   }
   $step1 = 0;
   while (defined %xash_out1)
   {
      $alnlength1 =  $alnlength - $step1;
      $distance_cut = $xash_dist{1}[$alnlength1 - 1];

      open (VIVODB , ">$outfile.$alnlength1.$distance_cut"); 
      if ($outformat eq "fasta")
      {
	 for $species (sort {$a <=> $b} keys %xash_out1)
	 {
	    print VIVODB ">$xashnames{$species}\n";
	    for $l (0.. $#{$xash_out1{$species}})
	    {	   
	       print VIVODB "$xash_out1{$species}[$l]";
	    }
	    print VIVODB "\n";
	 }   
	 close VIVODB;
      }

      if ($outformat eq "nexus")
      {
	 print VIVODB "#NEXUS\n\n";
	 print VIVODB "begin data\;\n";
	 print VIVODB "   dimensions ntax=$ntax nchar=$alnlength1\;\n";
	 print VIVODB "   format datatype=Nucleotide interleave=no gap=-\;\n";
	 print VIVODB "   matrix\n";
	 for $species (sort {$a <=> $b} keys %xash_out1)
	 {	
	   $dlina = length $xashnames{$species};
	   $ostatok = 30 - $dlina; 
	
	   print VIVODB "$xashnames{$species}";
	   for $b (1.. $ostatok)
	   {
	      print VIVODB " "; 
	   }
	   for $l (0.. $#{$xash_out1{$species}})
	    {	   
	       print VIVODB "$xash_out1{$species}[$l]";
	       #@{$seqblock{$species}} = split (/(\w{1,50})/, $xash_out1{$species}[$l]);
	    }
	    print VIVODB "\n";
	 }
	 print VIVODB "\;\n";
	 print VIVODB "end\;\n";
	 close VIVODB;
	 goto mark10;  
      }  
      if ($outformat eq "phylip")
      {
	 mark10:
	 $newprint = "1"."$outfile";
	 open (VIVODB , ">$newprint.$alnlength1.$distance_cut"); 
	 print VIVODB "$ntax   $alnlength1\n";
	 for $species (sort {$a <=> $b} keys %xash_out1)
	 {	
	    $dlina = length $xashnames{$species};
	    $ostatok = 30 - $dlina; 
	
	    print VIVODB "$xashnames{$species}";
	    for $b (1.. $ostatok)
	    {
	       print VIVODB " "; 
	    }
	    for $l (0.. $#{$xash_out1{$species}})
	    {	   
	       print VIVODB "$xash_out1{$species}[$l]";
	       #@{$seqblock{$species}} = split (/(\w{1,50})/, $xash_out1{$species}[$l]);
	    }
	    print VIVODB "\n";
	 }
	 close VIVODB; 
      }
      for $species (sort {$a <=> $b} keys %xash_out1)
      {
	 $hhh++;
	 if ($#{$xash_out1{$species}} >= $step)
	 {
	    for (1.. $step)
	    {  
	       $udaleno++;
	       $deleted_character = pop @{$xash_out1{$species}};
	       push @{$rest{$species}}, $deleted_character;
	    }
	 }
	 else
	 {
	    undef %xash_out1;
	 }	
      }   
      $udaleno1 = $udaleno/$hhh;
      $step1 = $step1 + $udaleno1;
      
      $distance_cut1 = $xash_dist{1}[$alnlength1 - 1 - $udaleno1];
      $blah = $alnlength1-$udaleno1;
   
   
   
      open (VIVODB, ">$outfile.$blah.deleted.$step1.$distance_cut1");
      open (VIVODN, ">$outfile.$blah.justdeleted.$step1.$distance_cut1");
      if ($outformat eq "fasta")
      {
         for $species (sort {$a <=> $b} keys %rest)
         {  
            $printed = 1;
            print VIVODB ">$xashnames{$species}\n";
            for ($l = $#{$rest{$species}}; $l >= 0; $l--)
            {      
	       print VIVODB "$rest{$species}[$l]";
	       if ($printed <= $step)
	       {
	          print VIVODN "$rest{$species}[$l]";
	          $printed++
	       }
            }
            print VIVODB "\n";print VIVODN "\n";
         }   
         close VIVODB;close VIVODN;
      }
      elsif ($outformat eq "phylip")
      {
         print VIVODB "$ntax   $step1\n";
         print VIVODN "$ntax   $step\n";
      
         for $species (sort {$a <=> $b} keys %rest)
         {	 
	    $dlina = length $xashnames{$species};
	    $ostatok = 30 - $dlina; 
            $printed = 1;
	 
	    print VIVODB "$xashnames{$species}";print VIVODN "$xashnames{$species}";
	    for $b (1.. $ostatok)
	    {
	       print VIVODB " ";print VIVODN " "; 
	    }
	    for ($l = $#{$rest{$species}}; $l >= 0; $l--)
            {      
               print VIVODB "$rest{$species}[$l]";
	       if ($printed <= $step)
	       {
	          print VIVODN "$rest{$species}[$l]";
	          $printed++
	       }
	       #@{$seqblock{$species}} = split (/(\w{1,50})/, $rest{$species}[$l]);
            }
            print VIVODB "\n";print VIVODN "\n";
         }
         close VIVODB; close VIVODN;  
      }
      elsif ($outformat eq "nexus")
      {
         print VIVODB "#NEXUS\n\n";
         print VIVODB "begin data\;\n";
         print VIVODB "   dimensions ntax=$ntax nchar=$step1\;\n";
         print VIVODB "   format datatype=Nucleotide interleave=no gap=-\;\n";
         print VIVODB "   matrix\n";
      
      
         print VIVODN "#NEXUS\n\n";
         print VIVODN "begin data\;\n";
         print VIVODN "   dimensions ntax=$ntax nchar=$step\;\n";
         print VIVODN "   format datatype=Nucleotide interleave=no gap=-\;\n";
         print VIVODN "   matrix\n";
      
         for $species (sort {$a <=> $b} keys %rest)
         {	 
	    $dlina = length $xashnames{$species};
	    $ostatok = 30 - $dlina; 
	    $printed = 1;

	    print VIVODB "$xashnames{$species}";print VIVODN "$xashnames{$species}";
	    for $b (1.. $ostatok)
	    {
	       print VIVODB " ";print VIVODN " "; 
	    }
	    for ($l = $#{$rest{$species}}; $l >= 0; $l--)
            {      
               print VIVODB "$rest{$species}[$l]";
	       if ($printed <= $step)
	       {
	          print VIVODN "$rest{$species}[$l]";
	          $printed++
	       }
	       #@{$seqblock{$species}} = split (/(\w{1,50})/, $rest{$species}[$l]);
            }
            print VIVODB "\n";print VIVODN "\n";
         }
         print VIVODB "\;\n";
         print VIVODB "end\;\n";
         close VIVODB;
      
         print VIVODN "\;\n";
         print VIVODN "end\;\n";
         close VIVODN;      
         
      }    
   }
}

########################################
#bootstrap (constraints are not applied)
########################################

if ($boot eq "boot")
{
   for $i (1.. $nr_of_replicates)
   {
      open (VIVODA, ">$infile.mode$mode.fixed_toboot$i") or die (sprintf ("cannot open $infile.mode$mode.fixed_toboot$i file for writing"));
      print VIVODA "$alignment$part1$modelname$part2$model$part31$infile"."_"."$modelname.mode$mode.$i"."bootree $part41";
      close VIVODA;

      
      $komanda = "nohup paup -n $infile.mode$mode.fixed_toboot$i";
      push @do_boot, $komanda;
   }
   thread(@do_boot);
   system "trepaup2phy bootree";
   system "cat *bootree*# > $infile.mode$mode.boottrees";
   system "mkdir $infile.mode$mode.BOOT";
   system "mv *toboot*  *bootree* $infile.mode$mode.BOOT";


   open (VVOD_CONTREES, "<$infile.mode$mode.boottrees");
   open (VIVOD_CONTREES, ">intree") or die (sprintf ("cannot open intree file for writing"));
   while (defined($stroka = <VVOD_CONTREES>))
   {
      $stroka =~ s/\d\.\d+e-\d+/0/g;
      print VIVOD_CONTREES $stroka;
   }  
   close VVOD_CONTREES;close VIVOD_CONTREES;
   if (-e "outtree")
   {
     system "rm outtree";
   }  
   if (-e "outfile")
   {
     system "rm outfile";
   }  
   system "rm *mtestraw";
   system "consense << BLOCK
y
BLOCK"; 
      
   system "mv intree $infile.mode$mode.boottrees_changed";
   system "mv outfile $infile.mode$mode.boot.outfile";
   system "mv outtree $infile.mode$mode.boot.outtree";
}
sub thread
{
   for $a (0.. $#_)
   {
      my $pid = fork();
      if ($pid) 
      {
	 # parent
	 push(@childs, $pid);
      } 
      elsif ($pid == 0) 
      {
	 # child
	 system "$_[$a]";
	 exit(0);
      } 
      else 
      {
	 die "couldnt fork: $!\n";
      }
   }
   foreach (@childs) 
   {
      waitpid($_, 0);
   }
}
system "rm mtest_block $outfile.-*";


