#!/usr/bin/perl -w    

my $mode = 2;
my $mtest_block = "#NEXUS 

[! ***** MODELFIT BLOCK -- MODELTEST 3.4 *****]

[The following command will calculate a NJ tree using the JC69 model of evolution]

BEGIN PAUP;
	DSet distance=JC objective=ME base=equal rates=equal pinv=0
	subst=all negbrlen=setzero;
	NJ showtree=no breakties=random;
End;

[!
***** BEGIN TESTING 56 MODELS OF EVOLUTION ***** ]

BEGIN PAUP;


Default lscores longfmt=yes;
Set criterion=like;

[!
** Model 1 of 56 * Calculating JC **]
lscores  1/ nst=1  base=equal  rates=equal  pinv=0
scorefile=model.scores replace; 
[!
** Model 2 of 56 * Calculating JC+I **]
lscores  1/ nst=1  base=equal  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 3 of 56 * Calculating JC+G**]
lscores  1/ nst=1  base=equal  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 4 of 56 * Calculating JC+I+G **]
lscores  1/ nst=1  base=equal  rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 

[!
** Model 5 of 56 * Calculating F81 **]
lscores  1/ nst=1  base=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 6 of 56 * Calculating F81+I **]
lscores  1/ nst=1  base=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 7 of 56 * Calculating F81+G **]
lscores  1/ nst=1  base=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 8 of 56 * Calculating F81+I+G **]
lscores  1/ nst=1  base=est  rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 

[!
** Model 9 of 56 * Calculating K80 **]
lscores  1/ nst=2  base=equal  tratio=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 10 of 56 * Calculating K80+I **]
lscores  1/ nst=2  base=equal  tratio=est  rates=equal  pin=est
scorefile=model.scores  append; 
[!
** Model 11 of 56 * Calculating K80+G **]
lscores  1/ nst=2  base=equal  tratio=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 12 of 56 * Calculating K80+I+G **]
lscores  1/ nst=2  base=equal  tratio=est  rates=gamma  shape=est pinv=est
scorefile=model.scores  append; 
 
[!
** Model 13 of 56 * Calculating HKY **]                
lscores  1/ nst=2  base=est  tratio=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 14 of 56 * Calculating HKY+I **] 
lscores  1/ nst=2  base=est  tratio=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 15 of 56 * Calculating HKY+G **] 
lscores  1/ nst=2  base=est  tratio=est  rates=gamma  shape=est  pinv=0  
scorefile=model.scores  append; 
[!
** Model 16 of 56 * Calculating HKY+I+G **] 
lscores  1/ nst=2  base=est  tratio=est  rates=gamma  shape=est  pinv=est  
scorefile=model.scores  append; 

[!
** Model 17 of 56 * Calculating TrNef **]                            [a b c d e f]
lscores  1/ nst=6  base=equal  rmat=est  rclass=(a b a a e a)  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 18 of 56 * Calculating TrNef+I **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 19 of 56 * Calculating TrNef+G **] 
lscores  1/ nst=6  base=equal rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 20 of 56 * Calculating TrNef+I+G **] 
lscores  1/ nst=6  base=equal  rmat=est rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 

[!
** Model 21 of 56 * Calculating TrN **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 22 of 56 * Calculating TrN+I **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 23 of 56 * Calculating TrN+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 24 of 56 * Calculating TrN+I+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 25 of 56 * Calculating K3P **]                              [a b c d e f]
lscores  1/ nst=6  base=equal  rmat=est  rclass=(a b c c b a)  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 26 of 56 * Calculating K3P+I **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 27 of 56 * Calculating K3P+G **] 
lscores  1/ nst=6  base=equal rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 28 of 56 * Calculating K3P+I+G **] 
lscores  1/ nst=6  base=equal  rmat=est rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 29 of 56 * Calculating K3Puf **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 30 of 56 * Calculating K3Puf+I **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 31 of 56 * Calculating K3Puf+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 32 of 56 * Calculating K3Puf+I+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 33 of 56 * Calculating TIMef **]                            [a b c d e f]
lscores  1/ nst=6  base=equal  rmat=est  rclass=(a b c c e a)  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 34 of 56 * Calculating TIMef+I **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 35 of 56 * Calculating TIMef+G **] 
lscores  1/ nst=6  base=equal rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 36 of 56 * Calculating TIMef+I+G **] 
lscores  1/ nst=6  base=equal  rmat=est rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 37 of 56 * Calculating TIM **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 38 of 56 * Calculating TIM+I **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 39 of 56 * Calculating TIM+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 40 of 56 * Calculating TIM+I+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 41 of 56 * Calculating TVMef **]                            [a b c d e f]
lscores  1/ nst=6  base=equal  rmat=est  rclass=(a b c d b e)  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 42 of 56 * Calculating TVMef+I **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 43 of 56 * Calculating TVMef+G **] 
lscores  1/ nst=6  base=equal rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 44 of 56 * Calculating TVMef+I+G **] 
lscores  1/ nst=6  base=equal  rmat=est rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 45 of 56 * Calculating TVM **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 46 of 56 * Calculating TVM+I **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 47 of 56 * Calculating TVM+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=0
scorefile=model.scores  append; 
[!
** Model 48 of 56 * Calculating TVM+I+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est  pinv=est
scorefile=model.scores  append; 


[!
** Model 49 of 56 * Calculating SYM **]                               [a b c d e f]
lscores  1/ nst=6  base=equal  rmat=est  rclass= (a b c d e f)  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 50 of 56 * Calculating SYM+I **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 51 of 56 * Calculating SYM+G **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=gamma  shape=est pinv=0  
scorefile=model.scores  append; 
[!
** Model 52 of 56 * Calculating SYM+I+G **] 
lscores  1/ nst=6  base=equal  rmat=est  rates=gamma  shape=est pinv=est  
scorefile=model.scores  append; 

[!
** Model 53 of 56 * Calculating GTR **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=0
scorefile=model.scores  append; 
[!
** Model 54 of 56 * Calculating GTR+I **] 
lscores  1/ nst=6  base=est  rmat=est  rates=equal  pinv=est
scorefile=model.scores  append; 
[!
** Model 55 of 56 * Calculating GTR+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est pinv=0  
scorefile=model.scores  append; 
[!
** Model 56 of 56 * Calculating GTR+I+G **] 
lscores  1/ nst=6  base=est  rmat=est  rates=gamma  shape=est pinv=est  
scorefile=model.scores  append; 


LOG STOP;

END;

[
lscores: tree/s
nst: number of substitution types
rmat: rate matrix
base= nucleotide frequencies
rates= rate of evolution for variable sites (same 
shape= alpha parameter of the gamma distribution
pinv= proportion of invariable sites
]

[The likelihood ratio test statistic is calculated as twice the difference between 
the log likelihood scores of the two models constrasted. When the model representing
the null hypothesis is a special case of the alternate model, this statistic 
fits a chi-square distribution with a number of degrees of freedom equal to the 
number of parameters that freely vary between the two models. A detailed explanation 
of the test of the model of DNA substitution can be found in Huelsenbeck and Crandall
Annu. Rev. Ecol. Syst. 1997. 28: 437-466]

[!***  END OF MODELTEST BLOCK  ***]";


my $part1 = "SET
INCREASE = AUTO
AUTOCLOSE = yes;
Begin PAUP;
SET CRITERION = LIKELIHOOD;
DEFAULT LSCORES LONGFMT = yes;
[!
** Calculating best model (AIC) "; 



$part2 = " **]
";


$part3 = "HSEARCH START=NJ SWAP=TBR; DESCRIBETREES / PLOT=PHYLOGRAM; SAVETREES FILE= ";


$part4 = " FORMAT=NEXUS BRLENS=yes;

LOG STOP;

END;
";


sub thread 
{
   for $a (0.. $#_)
   {
      $pid = fork();
      if ($pid) 
      {
         push(@childs, $pid);
      } 
      elsif ($pid == 0) 
      {
         system "$_[$a]";
         exit(0);
      } 
      else 
      {
         die "couldnt fork: $!\n";
      }
   }
   foreach (@childs) 
   {
      waitpid($_, 0);
   }
}


my $MAN = <<BLAH;
This script calls other scripts in the package and 
performs correlation tests described in: 
Goremykin VV, Nikiforova SV, Bininda-Emonds ORP, Automated removal of noisy
data in phylogenomic analyses. JME 2010. 71:319-331.

This script should be run in a directory containing one input file only.

Following programs should be in the path:
paup - named - "paup"
modeltest - named - "mtest"
consense from PHYLIP package - named - "consense"
trepaup2phy script  - named - "trepaup2phy"
sorter.pl script - named - "sorter.pl"
gamma_sorter.pl script  - named - "gamma_sorter.pl"

synopsis: NoiseReductor.pl arg1 arg2 arg3 arg4
arg1:	name of input alignment in nexus format (produced by SEAVIEW)
arg2:	integer - size [pos.] of each shortening step. 
arg3:	"1"/"2" - sets mode of character sorting, 1 - observed variability - based
	sorting, 2 - gamma rate based sorting.
arg4:	"1"/"2"/"3" - sets mode of model-fitting to sorted alignments created 
	1 - using NJ tree as a base tree,
	2 - using ML tree built with a fitted model as a base tree, and
	3 - as 2 but using custom tree in PHYLIP format as a base tree to sort the characters.
	    choose this only if arg3 is set to 2

if arg4 is set to 3, the script gamma_sorter.pl will look for the tree file
"arg1.usertree" in the current directory. This tree will be used to assign rates
to characters during gamma rate-based sorting. All model-fitting to partitions
created will be done using unconstrained ML trees built employing fitted models as base trees.

instead of setting arg4 to "3", and providing a custom tree for assigning rates
to characters, one can use a data-based tree for this purpose built with topological
constraints. To do so, one should set arg4 to "1" or "2" and put a tree file named
"constraints" in the current directory.
 

BLAH

$#ARGV>=2 || die ($MAN);
$infile = $ARGV[0];
$shortening_step = $ARGV[1];
$sorting_mode = $ARGV[2];
$model_fitting_mode_for_sorting = $ARGV[3];

-e $infile || die (sprintf ("cannot find %s file", $infile));
if ($model_fitting_mode_for_sorting == 1 or $model_fitting_mode_for_sorting == 2)
{
  $mode = $model_fitting_mode_for_sorting;
}
elsif ($model_fitting_mode_for_sorting == 3)
{
  $mode = 2;
}


if ($sorting_mode == 1)
{
   print "Starting sorter_compat.pl with a command:\nsorter.pl $infile $shortening_step nexus sort\n";
   system "sorter.pl $infile $shortening_step nexus sort";
   system "rm sort*.0.0* sort*.0.1*";
   
}
elsif ($sorting_mode == 2)
{
   print "Starting gamma_sorter.pl with a command:\ngamma_sorter.pl $infile noboot $model_fitting_mode_for_sorting nexus sort $shortening_step\n";
   system "gamma_sorter.pl $infile noboot $model_fitting_mode_for_sorting nexus sort $shortening_step";
   system "rm sort.-* *.0 *.1 *.2 *.3 *.4 *.5 *.6 *.7 *.8 *.9 *.10 *.11 *.12 *.13 *.14 *.15 *.16 *.17 *.18 *.19 *.20 *.21 *.22 *.23 *.24 *.25 *.26 *.27 *.28 *.29 *.30";
}
else
{
   die (sprintf ("sorting mode $sorting_mode is not implemented\"$sorting_mode\""));
}

print "\nThe sorting is completed and An, Bn and Cn partitions are created\n";

system "mkdir SOURCEFILES";
system "mv $infile* SOURCEFILES";



system "ls -r sort.* > list_of_paupfiles785";
open (VIVOD_P, ">mtest_block");
print VIVOD_P $mtest_block;

########################################
#creating paup files with custom modeltest blocks
########################################

open (VVOD_S, "<list_of_paupfiles785");
while (defined($stroka = <VVOD_S>) and $stroka =~ /([^ ]+)\n/)
{
   if ($stroka =~ /(.+\d+)\n/)
   {
      $inputfile = $1;
      system "cat $inputfile  mtest_block >  $inputfile.mtestraw";     
      open (VVOD_MT, "<$inputfile.mtestraw");
      $mtestfilename = ">$inputfile"."_1_mode.mtest";
      open (VIVOD_MT, ">$mtestfilename");
      while (defined($linia = <VVOD_MT>))
      {
         if ($linia =~ /^(scorefile\=)model\.scores( +[^ ]+)/)
         {
            $linia = "$1$inputfile"."_1_mode.models$2\n";
            print VIVOD_MT $linia;      
         }
         else
         {
            print VIVOD_MT $linia;      
         }
      }
      close VVOD_MT;
      close VIVOD_MT;
   }
} 

########################################
#model fitting using NJ tree
########################################

print "\nStarting to fit models to all partitions under mode $mode\n";
system "ls sort*.mtest > command_do_mtest";
open (VVOD_MT, "<command_do_mtest");

while (defined($stroka = <VVOD_MT>) and $stroka =~ /([^ ]+)\n/)
{    
    if ($stroka =~ /(.+_1_mode\.mtest)\n/)
    {
       $komanda = "nohup paup -n $1";
       push @do_mtest, $komanda;
    }
}
thread(@do_mtest);  

system "rm command_do_mtest mtest_block list_of_paupfiles785";
close VVOD_MT;


system "ls sort*.models > list356";
open (VVOD, "<list356");
while (defined($stroka = <VVOD>))
{
   
   if ($stroka =~ /(.+\d+)(_1_mode\.models)\n/)
   {
   $filename = $1;
   system "mtest < $1$2 > $1_1_mode\.bestmodel";
   open (VVODA, "<$1_1_mode\.bestmodel");
   $click = 0;
   while (defined($stroka = <VVODA>))
   {
     if ($stroka =~ /Hierarchical Likelihood Ratio Tests/)
     {
        $click = 0;
     }	
     if ($click == 0)
     {
        if ($stroka =~ /^Likelihood settings from best-fit model \((.+)\)/)
	{
	   $modelname0 = $1;	
	}
        if ($stroka =~ /^BEGIN PAUP/)
        {
           $stroka = <VVODA>;
           $model0 = $stroka;
	   chop $model0;
	   $model_type0 = 0;
	   if ($model0 =~ /Rmat=\(/)
	   {  
	      $model_type0 = 2;
	      if ($stroka =~ /(.+Rmat=\(.+ )(0.0000)( .+)/)
	      {  
	    	 $model0_part1 = $1;$model0_part2 = $2;$model0_part3 = $3;
	      }
	      else
	      {  
	    	 $stroka =~ m/(.+Rmat=\()(\d+\.\d+)(.+)/;
	   	 $model0_part1 = $1;$model0_part2 = $2;$model0_part3 = $3;
	      }
	   } 
	   elsif ($model0 =~ /Base=\(/)
	   {
	      $model_type0 = 1;
	      $stroka =~ m/(.+Base=\()(\d+\.\d+)(.+)/;
	      $model0_part1 = $1;$model0_part2 = $2;$model0_part3 = $3;
	   }
	   elsif ($model =~ /Rmat=/)
	   {
	      $model_type0 = 3;
 	      $model0_part1 = $stroka;$model0_part2 = "";$model0_part3 = "";
	   }
        }
     }
     if ($stroka =~ /Akaike/)
     {
        $click = 1;
     }	
     if ($click == 1)
     {
        if ($stroka =~ /^Likelihood settings from best-fit model \((.+)\)/)
	{
	   $modelname = $1;	
	}
        if ($stroka =~ /^BEGIN PAUP/)
        {
           $stroka = <VVODA>;
           $model = $stroka;
	   chop $model;
	   $model_type = 0;
	   if ($model =~ /Rmat=\(/)
	   {
	      $model_type = 2;
	      if ($stroka =~ /(.+Rmat=\(.+ )(0.0000)( .+)/)
	      {
	    	 
	    	 $model_part1 = $1;$model_part2 = $2;$model_part3 = $3;
	      }
	      else
	      {  
	    	 $stroka =~ m/(.+Rmat=\()(\d+\.\d+)(.+)/;
	   	 $model_part1 = $1;$model_part2 = $2;$model_part3 = $3;
	      }
	   } 
	   elsif ($model =~ /Base=\(/)
	   {
	      $model_type = 1;
	      $stroka =~ m/(.+Base=\()(\d+\.\d+)(.+)/;
	      $model_part1 = $1;$model_part2 = $2;$model_part3 = $3;
	   }
	   elsif ($model =~ /Rmat=/)
	   {
	      $model_type = 3;
 	      $model_part1 = $stroka;$model_part2 = "";$model_part3 = "";
	   }
	   print "optimal model for the file $filename was determined using NJ tree as a base tree:\n$model\n";
	   last;
        }
     }
   }
   close VVODA;
   if ($mode == 1 or $mode == 2)
   {
      system "ls $filename* > list987";
      open (VVODB, "<list987");
      while (defined($stroka = <VVODB>))
      {
	 if ($stroka =~ /($filename)\n/)
         {
            $paupfile= $1;
	    open (VVODC, "<$paupfile");
            $alignment = "";
	    while (defined($stroka = <VVODC>) and $stroka !~ "^end;")
            {
               $alignment = $alignment.$stroka;
	    }
	    $alignment = $alignment."end;\n";
	    close VVODC;
	    #*orig.fixed is a file for tree computation
	    $fixedfilename = "$paupfile"."_1"."_$modelname.orig.fixed";
	    open (VIVODA, ">$fixedfilename") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
	    print VIVODA "$alignment$part1$modelname$part2$model_part1$model_part2$model_part3\n$part3$filename"."_"."$modelname.pautree $part4";
	    close VIVODA;
            $complete_model = "";
 	    $imja_vvod = "$filename"."_1_"."$modelname.matrix";
            $uspeh = 0;
            if ($model_type == 3)
	    {
	       open (VIVODA, ">$paupfile"."_1_$modelname.modelfixed") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
	       print VIVODA "$alignment$model_part1$model_part2$model_part3\n"."dset distance=ml;\nnj;\nsavedist file=$imja_vvod format=nexus triangle=both;\n";
	       close VIVODA;
	       system "nohup paup -n $paupfile"."_1_$modelname.modelfixed";
               ($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l,$m) = stat $imja_vvod;
               if (defined $a)
               {
		     $uspeh = 1;
		     $complete_model="$model_part1$model_part2$model_part3";
	       }   
	    }
	    else
	    {
	       $dobavka = 0;$krugi = 0;$uspeh = 0;
	       while ($krugi <= 9)
	       {
		  open (VIVODA, ">$paupfile"."_1_$modelname.modelfixed") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
	          print VIVODA "$alignment$model_part1$model_part2$dobavka$model_part3\n"."dset distance=ml;\nnj;\nsavedist file=$imja_vvod format=nexus triangle=both;\n";
	          close VIVODA;
	          system "nohup paup -n $paupfile"."_1_$modelname.modelfixed";
		  ($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l,$m) = stat $imja_vvod;
		  if (defined $a)
		  {
		     $uspeh = 1;
		     $complete_model="$model_part1$model_part2$dobavka$model_part3";
		     last;
		  }   
	          else
	          {
	             $dobavka++;
	          }
	          $krugi++;
               }   
	    }
	    if ($uspeh == 0)
	    {
	       $unichtozhit = "$paupfile"."_1_$modelname.modelfixed";
	       system "rm $unichtozhit";
	       $imja_vvod = "$filename"."_1_"."$modelname0.matrix";
	       if ($model_type0 == 3)
	       {
	          open (VIVODA, ">$paupfile"."_1_$modelname0.modelfixed") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
	          print VIVODA "$alignment$model0_part1$model0_part2$model0_part3\n"."dset distance=ml;\nnj;\nsavedist file=$imja_vvod format=nexus triangle=both;\n";
	          close VIVODA;
	          system "nohup paup -n $paupfile"."_1_$modelname0.modelfixed";
                  ($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l,$m) = stat $imja_vvod;
                  if (defined $a)
                  {
		     $uspeh = 1;
		     $complete_model="$model0_part1$model0_part2$model0_part3";
		     $modelname = $modelname0;
	          }   
	       }
	       else
	       {
	          $dobavka = 0;$krugi = 0;$uspeh = 0;
	          while ($krugi <= 9)
	          {
		     open (VIVODA, ">$paupfile"."_1_$modelname0.modelfixed") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
	             print VIVODA "$alignment$model0_part1$model0_part2$dobavka$model0_part3\n"."dset distance=ml;\nnj;\nsavedist file=$imja_vvod format=nexus triangle=both;\n";
	             close VIVODA;
	             system "nohup paup -n $paupfile"."_1_$modelname0.modelfixed";
		     ($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l,$m) = stat $imja_vvod;
		     if (defined $a)
		     {
		        $uspeh = 1;
			$complete_model="$model0_part1$model0_part2$dobavka$model0_part3";
		        $modelname = $modelname0;			
		        last;
		     }   
	             else
	             {
	                $dobavka++;
	             }
	             $krugi++;
	          }   
	       }
	    }
	    if ($uspeh == 0)
	    {
	       $unichtozhit = "$paupfile"."_1_$modelname0.modelfixed";
	       system "rm $unichtozhit";
	       $imja_vvod = "$filename"."_1_"."estimated.matrix";
               open (VIVODA, ">$paupfile"."_1_estimated.modelfixed") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
               print VIVODA "$alignment\nnj;\nlscore 1/nst=6 rmatrix=estimate rates=gamma shape=estimate pinvar=estimate;\nlset rmatrix=previous shape=previous pinvar=previous;\ndset distance=ml;\nnj;\nsavedist file=$imja_vvod format=nexus triangle=both;\n";
               close VIVODA;
               system "nohup paup -n $filename"."_1_estimated.modelfixed";
	    }
	    $fixedfilename = "$paupfile"."_1"."_$modelname.new.fixed";
	    open (VIVODA, ">$fixedfilename") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
	    print VIVODA "$alignment$part1$modelname$part2$complete_model$part3$filename"."_"."$modelname.pautree $part4";
	    close VIVODA;
	    last;
         }
      }   
      close VVODB;
   }   
   ########################################
   #second mode of model-fitting
   ########################################
   if ($mode == 2)
   {
      $proverit = "$filename.mtestraw";
      ($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l,$m) = stat $proverit;
      open (VVOD_MT_NEXT, "<$filename.mtestraw");
      $dlja2nd = "$filename"."_$mode"."_mode.mtest";
      
      open (VIVOD_MT_NEXT, ">$dlja2nd");
      while (defined($linia = <VVOD_MT_NEXT>))
      {
         if ($linia =~ /(\[)The following command will calculate a NJ tree using the JC69 model of evolution(\]\n)/)
         {
	    $linia = "$1The following command will calculate a ML tree using $modelname model fitted using NJ tree$2";
            print VIVOD_MT_NEXT $linia;
            while (defined($linia = <VVOD_MT_NEXT>) and $linia !~ "End\;\n")
            {
            }   
	    print VIVOD_MT_NEXT "SET INCREASE = AUTO AUTOCLOSE = yes;\nBEGIN PAUP;\nDEFAULT LSCORES LONGFMT = yes;\nSET CRITERION = LIKELIHOOD;\n$complete_model$part3$filename"."_1_"."$modelname.nexustree $part4\n";
         }
         elsif ($linia =~ /^(scorefile\=)model\.scores( +[^ ]+)/)
         {
            $linia = "$1$filename"."_$mode"."_mode.models$2\n";
            print VIVOD_MT_NEXT $linia;	 
         }
         else
         {  
	    print VIVOD_MT_NEXT $linia;	 
         }
      }
      close VVOD_MT_NEXT;
      close VIVOD_MT_NEXT;
      
      $dlja2nd1 = "$filename"."_$mode"."_mode.models";
      $dlja2nd2 = "$filename"."_$mode"."_mode.bestmodel";
      
      $komanda = "nohup paup -n $dlja2nd";
      $komanda1 = "mtest < $dlja2nd1 > $dlja2nd2";
      push @do_mtest_next, $komanda;
      push @do_mtest_next1, $komanda1;
   }
   }
}

if ($mode == 2)
{
   thread(@do_mtest_next);  
   thread(@do_mtest_next1); 
   
   system "ls *2_mode.bestmodel > list_mode2_bestmodels";
   open (VVOD_BESTMODELS, "<list_mode2_bestmodels");
   while (defined($stroka = <VVOD_BESTMODELS>) and $stroka =~ /([^ ]+)_2_mode\.bestmodel\n/)
   {
      open (VVODA, "<$1_2_mode.bestmodel");
      $filename = $1;
      $click = 0;
      while (defined($stroka = <VVODA>))
      {
         if ($stroka =~ /Hierarchical Likelihood Ratio Tests/)
         {
            $click = 0;
         }	
         if ($click == 0)
         {
            if ($stroka =~ /^Likelihood settings from best-fit model \((.+)\)/)
	    {
	       $modelname0 = $1;	
	    }
            if ($stroka =~ /^BEGIN PAUP/)
            {
               $stroka = <VVODA>;
               $model0 = $stroka;
	       chop $model0;
	       $model_type0 = 0;

	       if ($model0 =~ /Rmat=\(/)
	       {  
	          $model_type0 = 2;
		  if ($stroka =~ /(.+Rmat=\(.+ )(0.0000)( .+)/)
		  {  
		     $model0_part1 = $1;$model0_part2 = $2;$model0_part3 = $3;
		  }
		  else
		  {  
		     $stroka =~ m/(.+Rmat=\()(\d+\.\d+)(.+)/;
	             $model0_part1 = $1;$model0_part2 = $2;$model0_part3 = $3;
	          }
	       } 
	       elsif ($model0 =~ /Base=\(/)
	       {
	          $model_type0 = 1;
	          $stroka =~ m/(.+Base=\()(\d+\.\d+)(.+)/;
	          $model0_part1 = $1;$model0_part2 = $2;$model0_part3 = $3;
	       }
	       elsif ($model =~ /Rmat=/)
	       {
	          $model_type0 = 3;
 	          $model0_part1 = $stroka;$model0_part2 = "";$model0_part3 = "";
	       }
            }
         }
         if ($stroka =~ /Akaike/)
         {
            $click = 1;
         }	
         if ($click == 1)
         {
            if ($stroka =~ /^Likelihood settings from best-fit model \((.+)\)/)
	    {
	       $modelname = $1;	
	    }
            if ($stroka =~ /^BEGIN PAUP/)
            {
	       $stroka = <VVODA>;
               $model = $stroka;
	       chop $model;
	       $model_type = 0;
	       if ($model =~ /Rmat=\(/)
	       {
		  $model_type = 2;
		  if ($stroka =~ /(.+Rmat=\(.+ )(0.0000)( .+)/)
		  {
		     $model_part1 = $1;$model_part2 = $2;$model_part3 = $3;
		  }
		  else
		  {  
		     $stroka =~ m/(.+Rmat=\()(\d+\.\d+)(.+)/;
	             $model_part1 = $1;$model_part2 = $2;$model_part3 = $3;
	          }
	       } 
	       elsif ($model =~ /Base=\(/)
	       {
	          $model_type = 1;
	          $stroka =~ m/(.+Base=\()(\d+\.\d+)(.+)/;
	          $model_part1 = $1;$model_part2 = $2;$model_part3 = $3;
	       }
	       elsif ($model =~ /Rmat=/)
	       {
	          $model_type = 3;
 	          $model_part1 = $stroka;$model_part2 = "";$model_part3 = "";
	       }
	       print "optimal model for the file $filename was determined using ML tree as a base tree:\n$model\n";
	       last;
            }
         }
      }
      close VVODA;


      system "ls $filename* > list_alignments";
      open (VVODB, "<list_alignments");
      while (defined($stroka = <VVODB>))
      {
         if ($stroka =~ /($filename)\n/)
         {
            $paupfile= $1;
	    open (VVODC, "<$paupfile");
            $alignment = "";
	    while (defined($stroka = <VVODC>) and $stroka !~ "^end;")
            {
               $alignment = $alignment.$stroka;
	    }
	    $alignment = $alignment."end;\n";
	    close VVODC;
	    
	    
	    $fixedfilename = "$paupfile"."_2"."_$modelname.orig.fixed";
	    open (VIVODA, ">$fixedfilename") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
	    print VIVODA "$alignment$part1$modelname$part2$model_part1$model_part2$model_part3$part3$filename"."_"."$modelname.pautree $part4";
	    close VIVODA;




            $fixedmodel = "";
	    $imja_vvod = "$filename"."_"."$mode"."_"."$modelname.matrix";
            $uspeh = 0;
            if ($model_type == 3)
	    {
	       open (VIVODA, ">$paupfile"."_2_$modelname.modelfixed") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
	       print VIVODA "$alignment$model_part1$model_part2$dobavka$model_part3\n"."dset distance=ml;\nnj;\nsavedist file=$imja_vvod format=nexus triangle=both;\n";
	       close VIVODA;
	       system "nohup paup -n $paupfile"."_2_$modelname.modelfixed";
               ($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l,$m) = stat $imja_vvod;
               if (defined $a)
               {
		     $uspeh = 1;
		     $fixedmodel= "$model_part1$model_part2$dobavka$model_part3";
	       }   
	    }
	    else
	    {
	       $dobavka = 0;$krugi = 0;$uspeh = 0;
	       while ($krugi <= 9)
	       {
		  open (VIVODA, ">$paupfile"."_2_$modelname.modelfixed") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
	          print VIVODA "$alignment$model_part1$model_part2$dobavka$model_part3\n"."dset distance=ml;\nnj;\nsavedist file=$imja_vvod format=nexus triangle=both;\n";
	          close VIVODA;
	          system "nohup paup -n $paupfile"."_2_$modelname.modelfixed";
		  ($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l,$m) = stat $imja_vvod;
		  if (defined $a)
		  {
		     $uspeh = 1;
		     $fixedmodel= "$model_part1$model_part2$dobavka$model_part3";
		     last;
		  }   
	          else
	          {
	             $dobavka++;
	          }
	          $krugi++;
               }   
	    }
	    if ($uspeh == 0)
	    {
	       $unichtozhit = "$paupfile"."_2_$modelname.modelfixed";
	       system "rm $unichtozhit";
	       $imja_vvod = "$filename"."_"."$mode"."_"."$modelname0.matrix";
               if ($model_type0 == 3)
	       {
	          open (VIVODA, ">$paupfile"."_2_$modelname0.modelfixed") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
	          print VIVODA "$alignment$model0_part1$model0_part2$model0_part3\n"."dset distance=ml;\nnj;\nsavedist file=$imja_vvod format=nexus triangle=both;\n";
	          close VIVODA;
	          system "nohup paup -n $paupfile"."_2_$modelname0.modelfixed";
                  ($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l,$m) = stat $imja_vvod;
                  if (defined $a)
                  {
		     $fixedmodel= "$model0_part1$model0_part2$model0_part3";
		     $modelname = $modelname0;
		     $uspeh = 1;
	          }   
	       }
	       else
	       {
	          $dobavka = 0;$krugi = 0;$uspeh = 0;
	          while ($krugi <= 9)
	          {
		     open (VIVODA, ">$paupfile"."_2_$modelname0.modelfixed") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
	             print VIVODA "$alignment$model0_part1$model0_part2$dobavka$model0_part3\n"."dset distance=ml;\nnj;\nsavedist file=$imja_vvod format=nexus triangle=both;\n";
	             close VIVODA;
	             system "nohup paup -n $paupfile"."_2_$modelname0.modelfixed";
		     ($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l,$m) = stat $imja_vvod;
		     if (defined $a)
		     {
		        $fixedmodel= "$model0_part1$model0_part2$dobavka$model0_part3";
		        $modelname = $modelname0;
		        $uspeh = 1;
		        last;
		     }   
	             else
	             {
	                $dobavka++;
	             }
	             $krugi++;
	          }   
	       }
	    }
            if ($uspeh == 0)
	    {
	       $unichtozhit = "$paupfile"."_2_$modelname0.modelfixed";
	       system "rm $unichtozhit";

	       
               system "ls $filename*_1_*nexustree# > lookup";
               open (VVODTREE, "<lookup") or die (sprintf ("cannot open lookup file for reading"));
               $treename = <VVODTREE>;
               close VVODTREE;
	       
               open (VVODTREE, "<$treename") or die (sprintf ("cannot open $treename file for reading"));
               $tree_tofitmodel = <VVODTREE>;
               close VVODTREE;
	       
	       $imja_vvod = "$filename"."_2_"."estimated.matrix";
               open (VIVODA, ">$paupfile"."_2_estimated.modelfixed") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
               print VIVODA "$alignment\nBEGIN TREES;\ntree usertree = [&U] $tree_tofitmodel\nEnd;\nlscore 1/nst=6 rmatrix=estimate rates=gamma shape=estimate pinvar=estimate;\nlset rmatrix=previous shape=previous pinvar=previous;\ndset distance=ml;\nnj;\nsavedist file=$imja_vvod format=nexus triangle=both;\n";
               close VIVODA;
               system "nohup paup -n $filename"."_2_estimated.modelfixed";
	    }

	    $fixedfilename = "$paupfile"."_2"."_$modelname.new.fixed";
	    open (VIVODA, ">$fixedfilename") or die (sprintf ("cannot open $paupfile.fixed file for writing"));
	    print VIVODA "$alignment$part1$modelname$part2$fixedmodel$part3$filename"."_"."$modelname.pautree $part4";
	    close VIVODA;
            last;
         }
      }   
      close VVODB;
   }    
   system "nohup trepaup2phy nexustree";
}


################################################
#matrix handling is below
################################################

print "Starting correlation analyses based on created distance matrices\n";

system "ls sort* > list_all";
open (VVODB, "<list_all");
while (defined($stroka = <VVODB>))
{
   if ($stroka =~ /(.+\d)\n/)
   {
      $alnname= $1;
      open (VVODC, "<$alnname");
      $alignment = "";
      while (defined($stroka = <VVODC>) and $stroka !~ "^end;")
      {
       $alignment = $alignment.$stroka;
      }
      $alignment = $alignment."end;\n";
      close VVODC;
      
      open (VIVODA, ">$alnname.pdist.fixed") or die (sprintf ("cannot open $alnname.pdist.fixed file for writing"));
      print VIVODA "$alignment \nnj;\nsavedist file=$alnname.pdist_3_.matrix format=nexus triangle=both;\n";
      close VIVODA;
      system "nohup paup -n $alnname.pdist.fixed";
   }
}    
$nazvanie = "";




if ((-s "config") && (-T "config"))
{ 
   open (VVOD_MATLIST, "<config");
   while (defined($stroka = <VVOD_MATLIST>))
   {
      $stroka =~ /^group1/ and $group = 1;
      $stroka =~ /^group2/ and $group = 2;
   
      if ($stroka !~ /^group/ and $stroka =~ /^([^ ]+)\n/)
      {
          $group == 1 and push @group1, $1; 
          $group == 2 and push @group2, $1;
      }	 
   }
   $udacha = 1;
}
else
{
   undef $udacha;  
}

$taxlabels = 0;

system "ls *.matrix > command12345";
open (VVOD_MATLIST, "<command12345");
while (defined($stroka = <VVOD_MATLIST>) and $stroka =~ /(.+)\n/)
{
   push @matrixi, $1;
}
for $q (0.. $#matrixi)
{
   if ($matrixi[$q] !~ /deleted/ and $matrixi[$q] !~ /pdist/)
   {
      $matrixi[$q] =~ m/(sort\.)(\d+).+_(\d)_/;
      $index_data = "$1$2"; $index_mode = $3; $length_data = $2;
      
      for $qq (0.. $#matrixi)
      {
         if ($matrixi[$qq]=~/deleted/ and $matrixi[$qq]!~/pdist/)
         {
            if ($matrixi[$qq]=~/justdeleted/ and $matrixi[$qq]!~/pdist/)
	    {
	       $comparison = 2;
	    }
	    else
	    {
	       $comparison = 1;
	    }
	    
	    $matrixi[$qq] =~ m/(sort\.\d+).+_(\d)_/;
	    if ($index_data eq $1 and $index_mode == $2)
	    {
                correlation();
	    }   		      
         }
      }
   }
}

for $q (0.. $#matrixi)
{
   if ($matrixi[$q] !~ /pdist/ and $matrixi[$q] =~ /deleted/)
   {
      $matrixi[$q] =~ m/(sort\.)(\d+).+_(\d)_/;
      $index_data = "$1$2"; $index_mode = $3; $length_data = $2;
      $matrixi[$q] =~ m/(.+)_\d_/;
      $imja1 = $1;
      $index_data = "$1";
      if ($matrixi[$q] =~ /\.deleted/)
      {
         $nazvanie = "deleted";
      }
      elsif ($matrixi[$q] =~ /\.justdeleted/)
      {
         $nazvanie = "justdeleted";
      }
      for $qq (0.. $#matrixi)
      {
         if ($matrixi[$qq]=~/pdist/ and $matrixi[$qq] =~ /deleted/)
         {
	    $comparison = "3";
	    
	    $matrixi[$qq] =~ m/(.+)\.pdist/;
	    if ($imja1 eq $1)
	    {
	       correlation();
	    }   		      
         }
      }
   }
}


for $i (sort {$b cmp $a} keys %pearson_out)
{   
   for $ii (sort {$b <=> $a} keys %{$pearson_out{$i}})
   {
      for $iii (sort {$b cmp $a} keys %{$pearson_out{$i}{$ii}})
      {
         $corr_output = "$i"."_"."comparison$ii"."_"."mode$iii.pearson_correlation";
         open (VIVOD_MAT, ">$corr_output");
         for $iiii (sort {$b <=> $a} keys %{$pearson_out{$i}{$ii}{$iii}})
         {
            print VIVOD_MAT "$iiii\t$pearson_out{$i}{$ii}{$iii}{$iiii}\n";
         }
         close VIVOD_MAT;
      }	 
   }
}



for $i (sort {$b cmp $a} keys %spearman_out)
{   
   for $ii (sort {$b <=> $a} keys %{$spearman_out{$i}})
   {
      for $iii (sort {$b cmp $a} keys %{$spearman_out{$i}{$ii}})
      {
         $corr_output = "$i"."_"."comparison$ii"."_"."mode$iii.spearman_correlation";
         open (VIVOD_MAT, ">$corr_output");
         for $iiii (sort {$b <=> $a} keys %{$spearman_out{$i}{$ii}{$iii}})
         {
            print VIVOD_MAT "$iiii\t$spearman_out{$i}{$ii}{$iii}{$iiii}\n";
         }
         close VIVOD_MAT;
      }	 
   }
}

for $i (sort {$b cmp $a} keys %deviation_out)
{   
   for $ii (sort {$b <=> $a} keys %{$deviation_out{$i}})
   {
      for $iii (sort {$b cmp $a} keys %{$deviation_out{$i}{$ii}})
      {
         $corr_output = "$i"."_"."comparison$ii"."_"."mode$iii.deviation";
         open (VIVOD_MAT, ">$corr_output");
         for $iiii (sort {$b <=> $a} keys %{$deviation_out{$i}{$ii}{$iii}})
         {
            print VIVOD_MAT "$iiii\t$deviation_out{$i}{$ii}{$iii}{$iiii}\n";
         }
         close VIVOD_MAT;
      }	 
   }
}




sub correlation
{
   open (VVOD_MAT, "<$matrixi[$q]");
   $aha = 0;$schitaju = 0;
   while (defined($stroka = <VVOD_MAT>))
   {	       
      $vidi=0;
      if ($stroka =~ /^	Taxlabels/)
      {		  
    	 $taxlabels++;
    	 if ($taxlabels == 1)
    	 {
    	    while (defined($stroka = <VVOD_MAT>) and $stroka =~ /^\t+([^ ]+)\n/ and $stroka !~ /;/)
	    {
    	       $vidi++;
    	       for $i (0.. $#group1)
    	       {
    		  if ($group1[$i] eq $1)
    		  {
    		     push @group1_number, $vidi;
    		  }
    	       }
    	       for $i (0.. $#group2)
    	       {
    		  if ($group2[$i] eq $1)
    		  {
    		     push @group2_number, $vidi;
    		  }
    	       }
    	    } 
	 }
      }
      if ($stroka =~ /^Begin distances/)
      {
         $aha = 1;
         $stroka = <VVOD_MAT>;$stroka = <VVOD_MAT>;
      }
      if ($stroka =~ /^([^ ]+) +(.+)/ and $aha == 1)
      {
         $schitaju++;
         @distances = split (/ +/, $2); 
         if (defined $udacha)
         {
            for $i (0.. $#group2_number)
            {
               if ($group2_number[$i] == $schitaju)
               {
	    	  for $ii (0.. $#distances)
        	  {
	    	     for $iii (0.. $#group1_number)  
	    	     {
        		if ($group1_number[$iii] == $ii + 1)
        		{
	    		   push @distances_chosen1, $distances[$ii];
	    		}
	    	     }
        	  }
	       }
            }				       
         }						       
         for $i (0.. $#distances)
         {
            if ($i + 1 < $schitaju)
	    {
               push @distances_total1, $distances[$i];
	    }	
         }
      }
   }
   close VVOD_MAT;

   open (VVOD_MAT, "<$matrixi[$qq]");		    

   $aha = 0;$schitaju = 0;
   while (defined($stroka = <VVOD_MAT>))
   {		   
      if ($stroka =~ /^Begin distances/)
      {
   	 $aha = 1;
    	 $stroka = <VVOD_MAT>;$stroka = <VVOD_MAT>;
      }
      if ($stroka =~ /^([^ ]+) +(.+)/ and $aha == 1)
      {
    	 $schitaju++;
    	 @distances = split (/ +/, $2); 
    	 if (defined $udacha)
    	 {
    	    for $i (0.. $#group2_number)
    	    {
    	       if ($group2_number[$i] == $schitaju)
    	       {
    		  for $ii (0.. $#distances)
    		  {
    		     for $iii (0.. $#group1_number)  
    		     {
    			if ($group1_number[$iii] == $ii + 1)
    			{
    			   push @distances_chosen2, $distances[$ii];
    			}
    		     }
    		  }
    	       }
   	    }				       
   	 }
    	 for $i (0.. $#distances)
    	 {
    	    if ($i + 1 < $schitaju)
    	    {
    	       push @distances_total2, $distances[$i];
    	    }	
    	 }
      }
   }
   close VVOD_MAT;

   push (@storage1, @distances_total1);
   push (@storage2, @distances_total2);

   for $raz (0.. 1)
   {
      if ($raz == 0)
      {
    	 $sravnivaju = "total";
    	 undef @distances_total1;undef @distances_total2;
    	 push (@distances_total1, @storage1);
    	 push (@distances_total2, @storage2);
    	 undef @storage1;undef @storage2;
      }
      elsif (defined $udacha)
      {
    	 if  ($raz == 1)
    	 {
    	    $sravnivaju = "subset";
    	    undef @distances_total1;undef @distances_total2;
    	    push (@distances_total1, @distances_chosen1);
    	    push (@distances_total2, @distances_chosen2);
   	    undef @distances_chosen1;undef @distances_chosen2;
    	 }
      }
      else
      {
    	 last;
      }   
      
      $corr = "$index_data"."_"."$sravnivaju"."_"."comparison$comparison"."_"."mode$index_mode.corr";
      open (VIVOD_MAT, ">$corr");
      $mean1 = 0; $mean2 = 0; 
      for $i (0.. $#distances_total1)
      {
   	 print VIVOD_MAT "$distances_total1[$i]\t$distances_total2[$i]\n";
    	 $mean1 = $mean1 + $distances_total1[$i];
    	 $mean2 = $mean2 + $distances_total2[$i];
      }      
      close VIVOD_MAT;
      $mean1 = $mean1/($#distances_total1 + 1);
      $mean2 = $mean2/($#distances_total2 + 1);
      $deviation = $mean1 - $mean2;

      $sumX = 0;$sumY = 0;$sumXY = 0;$sumXX = 0;$sumYY = 0;
      $nr1 = $#distances_total1+1;$nr2 = $#distances_total2+1;
      if ($nr1 == $nr2)
      {
   	 for $i (0.. $#distances_total1)
   	 {
   	    $sumX = $sumX + $distances_total1[$i];
   	    $sumY = $sumY + $distances_total2[$i];
   	    $XY = $distances_total1[$i] * $distances_total2[$i];
    	    $sumXY = $sumXY + $XY;
    	    
   	    $XX = $distances_total1[$i] * $distances_total1[$i];
    	    $sumXX = $sumXX + $XX;
    	    
   	    $YY = $distances_total2[$i] * $distances_total2[$i];
    	    $sumYY = $sumYY + $YY;
   	 }

    	 $pearson = ($nr1*$sumXY - $sumX*$sumY)/(sqrt($nr1*$sumXX - $sumX*$sumX)*sqrt($nr1*$sumYY - $sumY*$sumY));
    	 $pearson_out{$sravnivaju}{$comparison}{"$index_mode$nazvanie"}{$length_data} = $pearson;
    	 $comparison==3 and $deviation_out{$sravnivaju}{$comparison}{"$index_mode$nazvanie"}{$length_data} = $deviation;
    	 
    	 
    	 
    	 undef  %hash_ranks1; undef %hash_dist1; 
    	 undef  %hash_ranks2; undef %hash_dist2; 
    	 undef @tied;undef @tied1;undef @oboima;$krugi = 0;$sum_of_ranks = 0;
   	 push @oboima, 0;
   	 for $i (0.. $#distances_total1)
   	 {
   	    $hash_dist1{$i} = $distances_total1[$i];
   	 }
    	 for $i (sort {$hash_dist1{$b} <=> $hash_dist1{$a}} keys %hash_dist1)
    	 {
    	    $krugi++;
    	    if ($krugi > 1 and $hash_dist1{$i} eq $hash_dist1{$previous})
    	    {
    		 if ($oboima[$#oboima] == 0)
    		 {
    		    push @tied, $previous; push @tied1, $krugi-1;
    		    push @tied, $i;	   push @tied1, $krugi;
    		 }
    		 if ($oboima[$#oboima] == 1 and $tied[$#tied] == $previous)
    		 {
    		    push @tied, $i; push @tied1, $krugi;
    		 }
    		 push @oboima, 1;
    	    }
    	    else
    	    {
    	       if ($oboima[$#oboima] == 1)
    	       {
    		  $sum_of_ranks = 0;
    		  for $ii (0.. $#tied1)
    		  {
    		     $sum_of_ranks =  $sum_of_ranks + $tied1[$ii];
    		  }
    		  for $ii (0.. $#tied)
    		  {
    		     $hash_ranks1{$tied[$ii]} = $sum_of_ranks/($#tied+1);
    		  }
    		  undef @tied;undef @tied1;
    	       }
    	       push @oboima, 0;
    	       $hash_ranks1{$i} = $krugi;
    	    }
    	    $previous = $i;
    	 }
    	 if ($oboima[$#oboima] == 1)
    	 {
    	    $sum_of_ranks = 0;
    	    for $ii (0.. $#tied1)
    	    {
    	       $sum_of_ranks =  $sum_of_ranks + $tied1[$ii];
    	    }
    	    for $ii (0.. $#tied)
    	    {
    	       $hash_ranks1{$tied[$ii]} = $sum_of_ranks/($#tied+1);
    	    }
    	    undef @tied;undef @tied1;
    	 }
   	 $krugi = 0;
    	 
    	 undef @tied;undef @tied1;undef @oboima;$krugi = 0;$sum_of_ranks = 0;
   	 push @oboima, 0;

   	 for $i (0.. $#distances_total2)
   	 {
   	    $hash_dist2{$i} = $distances_total2[$i];
   	 }
    	 for $i (sort {$hash_dist2{$b} <=> $hash_dist2{$a}} keys %hash_dist2)
    	 {
    	    $krugi++;
    	    if ($krugi > 1 and $hash_dist2{$i} eq $hash_dist2{$previous})
    	    {
    		 if ($oboima[$#oboima] == 0)
    		 {
    		    push @tied, $previous; push @tied1, $krugi-1;
    		    push @tied, $i;	   push @tied1, $krugi;
    		 }
    		 if ($oboima[$#oboima] == 1 and $tied[$#tied] == $previous)
    		 {
    		    push @tied, $i; push @tied1, $krugi;
    		 }
    		 push @oboima, 1;
    	    }
    	    else
    	    {
    		if ($oboima[$#oboima] == 1)
    		{
    		   $sum_of_ranks = 0;
    		   for $ii (0.. $#tied1)
    		   {
    		      $sum_of_ranks =  $sum_of_ranks + $tied1[$ii];
    		   }
    		   for $ii (0.. $#tied)
    		   {
    		      $hash_ranks2{$tied[$ii]} = $sum_of_ranks/($#tied+1);
    		   }
    		   undef @tied;undef @tied1;
    		}
    		push @oboima, 0;
    		$hash_ranks2{$i} = $krugi;
    	    }
    	    $previous = $i;
    	 }
    	 if ($oboima[$#oboima] == 1)
    	 {
    	    $sum_of_ranks = 0;
    	    for $ii (0.. $#tied1)
    	    {
    	       $sum_of_ranks =  $sum_of_ranks + $tied1[$ii];
    	    }
    	    for $ii (0.. $#tied)
    	    {
    	       $hash_ranks2{$tied[$ii]} = $sum_of_ranks/($#tied+1);
    	    }
    	    undef @tied;undef @tied1;
    	 }
    	 $krugi = 0;		 


   	$sumX = 0;$sumY = 0;$sumXY = 0;$sumXX = 0;$sumYY = 0;
    	$nr1 = $#distances_total1+1;$nr2 = $#distances_total2+1;
    	for $i (0.. $#distances_total1)
    	{
    	   $sumX = $sumX + $hash_ranks1{$i};
    	   $sumY = $sumY + $hash_ranks2{$i};
    	   $XY = $hash_ranks1{$i} * $hash_ranks2{$i};
    	   $sumXY = $sumXY + $XY;
    	   
    	   $XX = $hash_ranks1{$i} * $hash_ranks1{$i};
    	   $sumXX = $sumXX + $XX;
    	   
    	   $YY = $hash_ranks2{$i} * $hash_ranks2{$i};
    	   $sumYY = $sumYY + $YY;
    	}
    	if (($nr1*$sumXX - $sumX*$sumX) >= 0)
    	{
    	   $toroot1 = $nr1*$sumXX - $sumX*$sumX;
    	}
    	else
    	{
    	   $toroot1 = 0 - ($nr1*$sumXX - $sumX*$sumX);
    	}
    	if (($nr1*$sumYY - $sumY*$sumY) >= 0)
    	{
    	   $toroot2 = $nr1*$sumYY - $sumY*$sumY;
    	}
    	else
    	{
    	   $toroot2 = 0 - ($nr1*$sumYY - $sumY*$sumY);
    	}
    	$spearman = ($nr1*$sumXY - $sumX*$sumY)/(sqrt($toroot1)*sqrt($toroot2));
    	$spearman_out{$sravnivaju}{$comparison}{"$index_mode$nazvanie"}{$length_data} = $spearman;
    	 
    	 undef  %hash_ranks1; undef %hash_dist1; 
    	 undef  %hash_ranks2; undef %hash_dist2; 
   	 undef @oboima;
      }
      else
      {
   	 print "PROBLEM\n";
      }

   }
   undef @distances_chosen1;
   undef @distances_chosen2;
   undef @distances_total1;
   undef @distances_total2;
}

system "rm list356 list987 command12345 list_alignments list_all *.mtestraw";

my $endnote = <<BLAHH;
#####################################################################################
Results of the correlation analyses are given in the files *correlation:
- correlations of evolutionary distances in A and B partitions are given in the files
with descriptor "comparison1"
- correlations of evolutionary distances in A and C partitions are given in the files
with descriptor "comparison2"
- correlations of non-corrected to evolutionary distances in B and C partitions
are given in the files with descriptor "comparison3"

deviations of the mean evolutionary distances from the mean uncorrected 
distances in B and C partitions are given in the files *deviation. Descriptor
"justdeleted" indicates C partitions, descriptor "deleted" indicates B partitions.

descriptor mode# in the output files indicates mode of model-fitting corresponding
to settings specified in arg4 of the script.

unsorted input file and all files produced during computation of the trees from 
this file (if any) were moved in the subdirectory SOURCEFILES
#####################################################################################
BLAHH
print $endnote;
